using System;
using System.Text.Json.Serialization;
namespace org.accordproject.calendar {
   using org.accordproject.time;
   using org.accordproject.geo;
   using concerto;
   abstract class CalendarComponent : Asset {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.CalendarComponent";
      public string uid { get; set; }
   }
   abstract class UniqueComponent : CalendarComponent {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.UniqueComponent";
      public string[] attendee { get; set; }
      public string[] comment { get; set; }
      public DateTime dtstamp { get; set; }
      public string organizer { get; set; }
      public string[] requestStatuses { get; set; }
      public string url { get; set; }
   }
   abstract class RecurringComponent : UniqueComponent {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.RecurringComponent";
      public string[] attachements { get; set; }
      public string[] categories { get; set; }
      public string classType { get; set; }
      public string[] contacts { get; set; }
      public DateTime created { get; set; }
      public string description { get; set; }
      public DateTime lastModified { get; set; }
      public int priority { get; set; }
      public string[] related { get; set; }
      public int sequence { get; set; }
      public string summary { get; set; }
   }
   class VAlarm : CalendarComponent {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.VAlarm";
      public string alarmAction { get; set; }
      public string attachment { get; set; }
      public string[] attendees { get; set; }
      public string description { get; set; }
      public Duration duration { get; set; }
      public int repeat { get; set; }
      public string summary { get; set; }
   }
   class VEvent : RecurringComponent {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.VEvent";
      public DateTime dtend { get; set; }
      public Duration duration { get; set; }
      public DateTime end { get; set; }
      public bool isAllDay { get; set; }
      public GeoCoordinates geo { get; set; }
      public string location { get; set; }
      public string[] resources { get; set; }
      public string transparency { get; set; }
      public bool isActive { get; set; }
   }
   class VFreebusy : UniqueComponent {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.VFreebusy";
      public DateTime dtstart { get; set; }
      public DateTime dtend { get; set; }
      public DateTime start { get; set; }
      public DateTime end { get; set; }
   }
   class VJournal : RecurringComponent {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.VJournal";
   }
   class VTodo : RecurringComponent {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.calendar.VTodo";
      public DateTime completed { get; set; }
      public DateTime due { get; set; }
      public Duration duration { get; set; }
      public GeoCoordinates geo { get; set; }
      public string location { get; set; }
      public int percentComplete { get; set; }
      public string[] resources { get; set; }
      public string todo { get; set; }
   }
}
